/* ============================================================
 *
 * This file is a part of the build-system-essentials project
 *
 * Copyright (C) 2012 by Johannes Wienke <jwienke at techfak dot uni-bielefeld dot de>
 *
 * This file may be licensed under the terms of the
 * GNU Lesser General Public License Version 3 (the ``LGPL''),
 * or (at your option) any later version.
 *
 * Software distributed under the License is distributed
 * on an ``AS IS'' basis, WITHOUT WARRANTY OF ANY KIND, either
 * express or implied. See the LGPL for the specific language
 * governing rights and limitations.
 *
 * You should have received a copy of the LGPL along with this
 * program. If not, go to http://www.gnu.org/licenses/lgpl.html
 * or write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 * The development of this software was supported by:
 *   CoR-Lab, Research Institute for Cognition and Robotics
 *     Bielefeld University
 *
 * ============================================================ */
#include <iostream>

#include <stdlib.h>
#include <math.h>

#include "library/MySimpleCCAComponent.h"

#include <cca/timing/HeartBeat.h>
#include <cca/processing/Timed.h>

using namespace std;
using namespace rsb;
using namespace cca;
using namespace cca::timing;
using namespace ccaessentials::library;

int main(int argc, char *argv[]) {
    
    cca::ComponentPtr Foo(new MySimpleCCAComponent(0.01));
    Foo->setProcessingStrategy(Timed::samplerate(10));
    Foo->configureInputPort("in", PortConfiguration::REMOTE("/lwr/command"));
    Foo->configureInputPort("fdb", PortConfiguration::REMOTE("/lwr/status/all/position"));
    Foo->configureOutputPort("out", PortConfiguration::REMOTE("/lwr/cmd/all/position"));
    std::cout << Foo->print() << std::endl;
    
    cca::timing::HeartBeatPtr beat = cca::timing::HeartBeat::LOCALREMOTE(10);
    beat->run();

    return EXIT_SUCCESS;
}

