/* ============================================================
 *
 * This file is a part of the build-system-essentials project
 *
 * Copyright (C) 2012 by Johannes Wienke <jwienke at techfak dot uni-bielefeld dot de>
 *
 * This file may be licensed under the terms of the
 * GNU Lesser General Public License Version 3 (the ``LGPL''),
 * or (at your option) any later version.
 *
 * Software distributed under the License is distributed
 * on an ``AS IS'' basis, WITHOUT WARRANTY OF ANY KIND, either
 * express or implied. See the LGPL for the specific language
 * governing rights and limitations.
 *
 * You should have received a copy of the LGPL along with this
 * program. If not, go to http://www.gnu.org/licenses/lgpl.html
 * or write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 *
 * The development of this software was supported by:
 *   CoR-Lab, Research Institute for Cognition and Robotics
 *     Bielefeld University
 *
 * ============================================================ */

#pragma once

#include <iostream>
#include <string>

#include <cca/Component.h>

#include <rci/dto/JointAngles.h>

namespace ccaessentials {
namespace library {

class MySimpleCCAComponent : public cca::Component {
public:

    MySimpleCCAComponent(double gain);

    virtual ~MySimpleCCAComponent();
    
    virtual void onProcess();
    
protected:
    cca::InputPort<rci::JointAngles>::Ptr IN;
    cca::InputPort<rci::JointAngles>::Ptr FDB;
    cca::OutputPort<rci::JointAngles>::Ptr OUT;
    
    /// Controller gain
    double cgain;
};

}
}
